//***************************************************************************
// Agat RT, Russia, Moscow, tel.+7(495)799-90-69, +7(495)656-54-92, +7(495)656-55-92
// Alder Driver Error Header File
// 31/10/2006 Version 3.70.123.62
// Board load file 123 and higher
//***************************************************************************

#if !defined(A9_DEBUG_HEADER)
#define A9_DEBUG_HEADER

#include "Aldr9.h"

// Debug routins
#define drvA9FirstDebugCmd			0x00000700

#define drvA9GetIDMATable			DrvIdent+ 0x00000700
#define drvA9GetLinesTable			DrvIdent+ 0x00000710
#define drvA9GetDebugData			DrvIdent+ 0x00000720
#define drvA9GetConfData			DrvIdent+ 0x00000730
#define drvA9SetE1MonitorMode		DrvIdent+ 0x00000740
#define drvA9GetE1MonitorData		DrvIdent+ 0x00000750
#define drvA9GetLogCommands			DrvIdent+ 0x00000760
#define drvA9GetE1MonitorTS			DrvIdent+ 0x00000770
#define drvA9SetVoiceIoMode			DrvIdent+ 0x00000780
#define drvA9SetIsdnEmuMode			DrvIdent+ 0x00000790

#define drvA9LastDebugCmd			0x00000790

#pragma pack(4)

typedef struct tagAdspLinesTable
{	
	DWORD		dwIDMAID;
	DWORD		dwFirstLine;
	DWORD		dwLinesAmount;
	DWORD 		dwVoiceLinesAmount;
} AdspLinesTable;

typedef struct _tagDebugData
{
	DWORD dwIrqCount;
	DWORD dwDebug;
	DWORD dwIDMA;
	DWORD dwPack;
	DWORD dwLoadTrace;
	WORD  lpwPack[40];
} DebugData;

#define E1MonitorDisable	0x00
#define E1Q921Monitor		0x01
#define E1Q931Monitor		0x02
#define E1Q921Q931Monitor	0x03
#define E1CASMonitor		0x02
#define E1MFRMonitor		0x08
#define E1CASMFRMonitor		0x0C

typedef struct _tagE1MonitorParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwMode;
} E1MonitorParams;

typedef struct _tagE1MonitorDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1MonitorDataParams;

typedef struct _tagLogCmdDataParams
{
	DWORD dwBoardHandle;
	DWORD dwIDMA;
} LogCmdDataParams;

typedef struct _tagIdentLineParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
} IdentLineParams;

typedef struct _tagE1MonitorTSInfo
{
	DWORD dwConnectionNumber;
	DWORD dwTimeSlotNumber;
} E1MonitorTSInfo;

typedef struct _tagVoiceIoModeParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} VoiceIoModeParams;

#define LOG_MESSAGE_MEDIA		0xEBCD00AF

#define LogType_Event					1
#define LogType_Command					2
#define LogType_Message					3
#define LogType_String					4

#define LogEvent_ResourceMapUpdated		1
#define LogEvent_ResourceOpened			2
#define LogEvent_ResourceClosed			3

#define LogType_Driver					0
#define LogType_Device					1
#define LogType_Attic					2
#define LogType_E1Line					3
#define LogType_InterfaceResource		4
#define LogType_VoiceResource			5

#ifndef LogValueHex
#define LogValueHex						1
#define LogValueDec						2
#define LogValueString					3
#define LogValueByteHex					4
#define LogValueWordHex					5
#define LogValueDwordHex				6
#endif

typedef struct _tagLogMessage
{
	DWORD dwLenInBytes;
	DWORD dwMedia;
	DWORD dwMajor;
	DWORD dwMinor;
	LARGE_INTEGER qwDateAndTime;
	DWORD dwDeviceHandle;
	DWORD dwAtticNumber;
	DWORD dwLineNumber;
	DWORD dwLineType;
	DWORD dwResType;
	BYTE  lpbData[512];
} LogMessage;

typedef struct _tagLogMessageHeader
{
	DWORD dwLenInBytes;
	DWORD dwMedia;
	DWORD dwMajor;
	DWORD dwMinor;
	LARGE_INTEGER qwDateAndTime;
	DWORD dwDeviceHandle;
	DWORD dwAtticNumber;
	DWORD dwLineNumber;
	DWORD dwLineType;
	DWORD dwResType;
} LogMessageHeader;

typedef struct _tagTAdspValueData
{
	DWORD dwPage;
	DWORD dwAddr;
}TAdspValueData;

typedef struct _tagTIsdnEmuData
{
	DWORD dwBasePort;
	DWORD dwMode;			// 0 - Standart mode, 1 - Add emulation mode
	DWORD dwAdspNumber;
	DWORD dwChanNumber;		// Channel Emulaton number
	TAdspValueData Mode;	// 0 - standart mode, 1 - Emulation mode
	TAdspValueData BufAddr;	
	TAdspValueData BufSize;
	TAdspValueData WritePtr;
	TAdspValueData ReadPtr;
	TAdspValueData ChanNumber;
} TIsdnEmuData;
#pragma pack()

#endif
